<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="formModel"
            :hidden-data="{
                id: formModel.id ?? '',
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const banks = ref([]);

const formFields = computed(() => {
    return [
        {
            type: 'select',
            name: 'bank_id',
            label: $i18n.t('bank'),
            placeholder: $i18n.t('please_select'),
            options: banks.value.map(r => {
                return {
                    value: String(r.id),
                    text: r[`name_${$i18n.locale.value}`] + (r.country ? ('[' + r.country.name + ']') : ''),
                };
            }),
        },
        {
            type: 'text',
            name: 'account_name',
            label: $i18n.t('bank_account_holder_name'),
        },
        {
            type: 'text',
            name: 'account_number',
            label: $i18n.t('bank_account_number'),
        }
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/other/company_bank/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/other/company_bank/build_form', {
            id: props.formModel ? props.formModel.id : '',
        });

        if (data.model) {
            model.value = data.model;
        }

        if (data.banks) {
            banks.value = data.banks;
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
